package eel6788.agents;

/**
 * This is a very simple agent which beacons every 10 seconds.
 */
import java.util.List;

import yaes.framework.agent.ACLMessage;
import yaes.framework.world.sensornetwork.AbstractSensorAgent;
import yaes.framework.world.sensornetwork.Perception;
import yaes.framework.world.sensornetwork.SensingHistory;
import yaes.framework.world.sensornetwork.SensorNetworkWorld;
import eel6788.MessageConstants;

public class SimpleSensorAgent extends AbstractSensorAgent implements
		MessageConstants {
	public SimpleSensorAgent(String name, SensorNetworkWorld sm) {
		super(name, sm);
	}

	@Override
	public void action() {
		// read out his stuff from the sensing manager
		final SensingHistory sensingHistory =
				getSensorWorld().getSensingHistory(getNode());
		final List<Perception> perceptions = sensingHistory.getMailbox();
		// send a message
		if (world.getTime() % 10 == 0) {
			final ACLMessage message =
					new ACLMessage(getNode().getName(),
							ACLMessage.Performative.INFORM);
			message.setValue(MessageConstants.FIELD_CONTENT, "Beacon");
			message.setDestination("*");
			transmit(message);
		}
	}
}
